
//
// Real Time Linux Example of Control outputs
//
// Bill Crum
// New Mexico Tech
// tobor@nmt.edu
// This is only an example. No guarantees are expressed.
//


#include "controls.h"


// The scope is check the real-time fifo every 50 ms.
// The scope is not in real-time, it displays data that was collected
// from real-time tasks.

ControlTimer::ControlTimer( QWidget *parent ) : QTimer( parent ), interval( 500 )
{
    initMetaObject();
    start( interval );
}

// Pause button to look a signal


//
// Creates the Scope widget
//

Controls::Controls( QWidget *parent, const char *name )
    : QFrame( parent, name )
{
    initMetaObject();				// initialize meta object
    timer = new ControlTimer(this);
        QLabel *msgLabel0 = new QLabel( this, "msgLabel0" );
    msgLabel0->setFont( QFont("times",18) );
    msgLabel0->setText( "Controls:" );
    msgLabel0->setAlignment( AlignLeft|AlignVCenter );
    msgLabel0->setGeometry( 10,5, 100, 20 );

        QLabel *msgLabel10 = new QLabel( this, "msgLabel10" );
    msgLabel10->setFont( QFont("times",18) );
    msgLabel10->setText( "OPEN:" );
    msgLabel10->setAlignment( AlignLeft|AlignVCenter );
    msgLabel10->setGeometry( 135,5, 80, 20 );

        QLabel *msgLabel20 = new QLabel( this, "msgLabel20" );
    msgLabel20->setFont( QFont("times",18) );
    msgLabel20->setText( "CLOSED:" );
    msgLabel20->setAlignment( AlignLeft|AlignVCenter );
    msgLabel20->setGeometry( 210,5, 85, 20 );

        QLabel *msgLabel1 = new QLabel( this, "msgLabel1" );
    msgLabel1->setFont( QFont("times",18) );
    msgLabel1->setText( "Relay 1:" );
    msgLabel1->setAlignment( AlignRight|AlignVCenter );
    msgLabel1->setGeometry( 5,30, 70, 20 );
    relay1Disabled = 1;

    msgLabel41 = new QLabel( this, "msgLabel41" );
    msgLabel41->setFont( QFont("times",18) );
    msgLabel41->setText( "DISABLED:" );
    msgLabel41->setAlignment( AlignRight|AlignVCenter );
    msgLabel41->setGeometry( 5,55, 100, 20 );

    QLabel *msgLabel2 = new QLabel( this, "msgLabel2" );
    msgLabel2->setFont( QFont("times",18) );
    msgLabel2->setText( "Relay 2:" );
    msgLabel2->setAlignment( AlignRight|AlignVCenter );
    msgLabel2->setGeometry( 5,90, 70, 20 );

    msgLabel42 = new QLabel( this, "msgLabel42" );
    msgLabel42->setFont( QFont("times",18) );
    msgLabel42->setText( "DISABLED:" );
    msgLabel42->setAlignment( AlignRight|AlignVCenter );
    msgLabel42->setGeometry( 5,115, 100, 20 );
    relay2Disabled = 1;
    relayOn1 = new QLabel(this, "relayon1");
    relayOn1->setFont( QFont("times",18) );
    relayOn1->setText( "0 ms" );
    relayOn1->setAlignment( AlignRight|AlignVCenter );
    relayOn1->setGeometry( 105,35, 80, 20 );

    relayOn2 = new QLabel(this, "relayon2");
    relayOn2->setFont( QFont("times",18) );
    relayOn2->setText( "0 ms" );
    relayOn2->setAlignment( AlignRight|AlignVCenter );
    relayOn2->setGeometry( 105,95, 80, 20 );

    relayOff1 = new QLabel(this, "relayoff1");
    relayOff1->setFont( QFont("times",18) );
    relayOff1->setText( "0 ms" );
    relayOff1->setAlignment( AlignRight|AlignVCenter );
    relayOff1->setGeometry( 205,35, 70, 20 );

    relayOff2 = new QLabel(this, "relayoff2");
    relayOff2->setFont( QFont("times",18) );
    relayOff2->setText( "0 ms" );
    relayOff2->setAlignment( AlignRight|AlignVCenter );
    relayOff2->setGeometry( 205,95, 70, 20 );
 

    QScrollBar *sb1 = new QScrollBar( 0, 100, 1, 1, 0, QScrollBar::Horizontal,this, "scrollbar");
    QScrollBar *sb2 = new QScrollBar( 0, 100, 1, 1, 0, QScrollBar::Horizontal,this, "scrollbar");
    QScrollBar *sb3 = new QScrollBar( 0, 100, 1, 1, 0, QScrollBar::Horizontal,this, "scrollbar");
    QScrollBar *sb4 = new QScrollBar( 0, 100, 1, 1, 0, QScrollBar::Horizontal,this, "scrollbar");
    sb1->setGeometry ( 120, 60, 75, 16 );
    sb2->setGeometry ( 210, 60, 75, 16 );
    sb3->setGeometry ( 120, 120, 75, 16 );
    sb4->setGeometry ( 210, 120, 75, 16 );

    connect( sb1, SIGNAL(valueChanged(int)), SLOT(relay1scrollBarOn(int)) );
    connect( sb2, SIGNAL(valueChanged(int)), SLOT(relay1scrollBarOff(int)) );
    connect( sb3, SIGNAL(valueChanged(int)), SLOT(relay2scrollBarOn(int)) );
    connect( sb4, SIGNAL(valueChanged(int)), SLOT(relay2scrollBarOff(int)) );


    pb1 = new QPushButton( "relay1", this );
    pb1->setToggleButton( TRUE );
    pb1->resize( 10, 10 );
    pb1->move( 100,35 );

    pb2 = new QPushButton( "relay2", this );
    pb2->setToggleButton( TRUE );
    pb2->resize( 10, 10 );
    pb2->move( 100,95 );

    connect( pb1, SIGNAL(clicked()), SLOT(relay1ButtonClicked()) );
    connect( pb2, SIGNAL(clicked()), SLOT(relay2ButtonClicked()) );


    if ((relay1_out = open("/dev/rtf10", O_WRONLY)) < 0) {
      fprintf(stderr, "Error opening /dev/rtf10\n");
      exit(1);
    }
    if ((relay2_out = open("/dev/rtf11", O_WRONLY)) < 0) {
      fprintf(stderr, "Error opening /dev/rtf11\n");
      exit(1);
    }
 
    
    setFrameStyle( QFrame::Box | QFrame::Raised );

    setLineWidth( 2 );				// set frame line width
 
    relay1[0] = 0;
    relay1[1] = 0;
    relay2[0] = 0;
    relay2[1] = 0;


}


void Controls::radioButtonClicked( int value )
{
  printf("button clicked %d\n",value);
}
void Controls::relay1ButtonClicked( )
{
  char disablerelay[2];
  if (relay1Disabled)
    {
      msgLabel41->setText( "ENABLED:" );
      relay1Disabled = 0;
      write (relay1_out, relay1, 2);

      printf("%d %d\n",relay1[1],relay1[0]);
    }
  else
    {
      msgLabel41->setText( "DISABLED:" );
      relay1Disabled = 1;
      disablerelay[0] = 0;
      disablerelay[1] = 0;
      write(relay1_out, disablerelay, 2);

      printf("%d %d\n",disablerelay[1],disablerelay[0]);
    }

}
void Controls::relay2ButtonClicked( )
{
  char disablerelay[2];
  if (relay2Disabled)
    {
      msgLabel42->setText( "ENABLED:" );
      relay2Disabled = 0;
      write (relay2_out, relay2, 2);
      printf("%d %d\n",relay2[1],relay2[0]);
    }
  else
    {
      msgLabel42->setText( "DISABLED:" );
      relay2Disabled = 1;
      disablerelay[0] = 0;
      disablerelay[1] = 0;
      write(relay2_out, disablerelay, 2);
      printf("%d %d\n",disablerelay[1],disablerelay[0]);
    }

}

void Controls::relay1scrollBarOff( int value )
{
  QString str;
  
  str.sprintf( "%d ms",(value * 10));
  relayOff1->setText( str );
  relay1[0] = value;
  printf("%d %d\n",relay1[1],relay1[0]);
  if (!relay1Disabled)
    write(relay1_out, relay1, 2);

}

void Controls::relay2scrollBarOff( int value )
{
  QString str;
  
  str.sprintf( "%d ms",(value * 10));
  relayOff2->setText( str );
  relay2[0] = value;
  printf("%d %d\n",relay2[1],relay2[0]);
  if (!relay2Disabled)
    write(relay2_out, relay2, 2);


}

void Controls::relay1scrollBarOn( int value )
{
  QString str;
  
  str.sprintf( "%d ms",(value * 10));
  relayOn1->setText( str );
  relay1[1] = value;
  printf("%d %d\n",relay1[1],relay1[0]);
  if (!relay1Disabled)
    write(relay1_out, relay1,2);


}

void Controls::relay2scrollBarOn( int value )
{
  QString str;
  
  str.sprintf( "%d ms",(value * 10));
  relayOn2->setText( str );
  relay2[1] = value;
  printf("%d %d\n",relay2[1],relay2[0]);
  if (!relay2Disabled)
    write(relay2_out, relay2,2);

}



//
// Handles timer events for the scope widget.
//

//void ScopeCanvas::timerEvent( QTimerEvent *e )
//{
//  showSignal();/
//}

//
// Enters date mode when the left mouse button is pressed.
//

//void Scope::mousePressEvent( QMouseEvent *e )
//{
//    if ( e->button() == LeftButton )		// left button pressed
//	showDate();
//}

//void ScopeCanvas::hold()
//{
// if (holdDisplay)
//   holdDisplay = 0;
// else
//   holdDisplay = 1;
//}


#if 0

void ScopeCanvas::set_voltage_scale(int scale)
{
  switch (scale)
    {
    case 0:
      voltage_scale = 1;
      center_scale = 0;
      break;
    case 1:
      voltage_scale = 2.5;
      center_scale = 3072;
      break;
    case 2:
      voltage_scale = 5;
      center_scale = 8192;
      break;
    case 3:
      voltage_scale = 4;
      break;
    }
}

void ScopeCanvas::set_time_scale(int scale)
{
  switch(scale)
    {
    case 0:
      time_scale = 10;
      break;
    case 1:
      time_scale = 25;
      break;
    case 2:
      time_scale = 50;
      break;
    case 3:
      time_scale = 100;
      break;
    }
}


//
// Shows the current date in the internal lcd widget.
// Fires a timer to stop showing the date.
//

void Scope::showDate()
{

  //    if ( showDateTimer != -1 )			// already showing date
  //return;
  //QDate d = QDate::currentDate();
  //QString s;
  //s.sprintf( "%2d %2d", d.month(), d.day() );
  //display( s );				// sets the LCD number/text
  //showDateTimer = startTimer( 2000 );		// keep this state for 2 secs
}

//
// Stops showing the date.
//

void ScopeCanvas::stopDate()
{
  //killTimer( showDateTimer );
  //showDateTimer = -1;
  //showTime();
}

//
// Displays the data by drawing straight lines between points.
//

void ScopeCanvas::showSignal()
{
  double new_scale;
  QPainter paint;
  paint.begin(this);
  paint.setWindow( 0,0,1000,(int)(4096 * voltage_scale) );//1300
  
  paint.setPen(blue);
  while (rt_fifo_get(2, &inbyte,2) > 0)
    {
      x  += time_scale;
      if (x < 1010)
	{
	  y = (unsigned int) inbyte[1];
	  y = y << 8;
	  y &= 0xff00;
	  y += (unsigned int) inbyte[0];
	  y &= 0xffff;
	  y = y >> 4;
	  //	  printf("%x %d\n",y,y);
	  y = (y + center_scale);
	  paint.drawLine(oldx,oldy,x,y); 
	  oldx = x;
	  oldy = y;
	}
      else
	break;
    }
  paint.end();
  if (x > 1050)
    {
      if (!holdDisplay)
        {
          x = 4;
          oldx = x;
          clear();
        }
    }
}


void ScopeCanvas::clear()
{
      repaint();

      QPainter paint;
      paint.begin( this ); 
      paint.setWindow( 0,0,400,300 );


  paint.setPen(green);
  paint.drawLine(40,4,40,296);
  paint.drawLine(80,4,80,296);
  paint.drawLine(120,4,120,296);
  paint.drawLine(160,4,160,296);
  paint.drawLine(200,4,200,296);
  paint.drawLine(240,4,240,296);
  paint.drawLine(280,4,280,296);
  paint.drawLine(320,4,320,296);
  paint.drawLine(360,4,360,296);

  paint.drawLine(4,30,396,30);
  paint.drawLine(4,60,396,60);
  paint.drawLine(4,90,396,90);
  paint.drawLine(4,120,396,120);
  paint.drawLine(4,150,396,150);
  paint.drawLine(4,180,396,180);
  paint.drawLine(4,210,396,210);
  paint.drawLine(4,240,396,240);
  paint.drawLine(4,270,396,270);

  
  paint.end();

      //    showingColon = !showingColon;		// toggle/blink colon
      //QString s = QTime::currentTime().toString().left(5);
      //if ( !showingColon )
      //	s[2] = ' ';
      //if ( s[0] == '0' )
      //	s[0] = ' ';
      //display( s );				// set LCD number/text
}


#endif




