//
// Real Time Linux Example of a oscilloscope Widget
//
//
//

#ifndef CONTROLS_H
#define CONTROLS_H

#include "das1600.h"


#include <stdio.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include <qtimer.h>
#include <qframe.h>
#include <qcombo.h>
#include <qevent.h>
#include <qpushbt.h>
#include <qlabel.h>
#include <qlcdnum.h>
#include <qbttngrp.h>
#include <qradiobt.h>
#include <qscrbar.h>


class ControlTimer : public QTimer
{
    Q_OBJECT
public:
    ControlTimer( QWidget *parent );
    enum { MAXSPEED = 1000 };

public slots:
//    void        pause( bool );

private:
    int         interval;
};


class Controls : public QFrame		// digital clock widget
{
    Q_OBJECT
public:
    Controls( QWidget *parent=0, const char *name=0 );
    int time_scale;
protected:					// event handlers
//    void	timerEvent( QTimerEvent * );
//    void	mousePressEvent( QMouseEvent * );



private slots:					// internal slots
    void        relay1scrollBarOff( int );
    void        relay2scrollBarOff( int );
    void        relay1scrollBarOn( int );
    void        relay2scrollBarOn( int );
    void        radioButtonClicked( int );
    void        relay1ButtonClicked( );
    void        relay2ButtonClicked( );

//    void	stopDate();
//    void        clear();
//    void	showState();
//    void set_voltage_scale(int);
private:					// internal data
    enum { TOPBORDER = 70, SIDEBORDER = 10 };
    ControlTimer  *timer;
    QPushButton  *pb1;
    QPushButton  *pb2;
    QLCDNumber *ana2;
    QLabel *msgLabel41;
    QLabel *msgLabel42;
    QLabel *msgLabel8;
    QLabel *control1;
    QLabel *control2;
    QLabel *relayOn1;
    QLabel *relayOn2;
    QLabel *relayOff1;
    QLabel *relayOff2;
    char relay1[2];
    char relay2[2];
    int relay1_out, relay2_out;
    void	showDate();
    int relay1Disabled, relay2Disabled;
    bool	showingColon;
    int         x,y,oldx,oldy;
    unsigned char inbyte;
    int		showDateTimer;

};




#endif // CONTROLS_H
